
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import java.util.ArrayList;

/**
 * This class is a parser for XML files
 */
public class SAXHandler extends DefaultHandler{
    /**
     * history of previous tag
     */
    String priviousTag;

    /**
     * list of retrived news
     */
    ArrayList news;

    /**
     * The constructor
     * @param mynews list of the news
     */
    SAXHandler(ArrayList mynews) {
        news = mynews;
        priviousTag = "";
    }

    /**
     * Trigger when element starts
     * @see DefaultHandler
     */
    public void startElement(String namespaceURI, String sName,
                             String qName, Attributes attrs) throws SAXException {
        priviousTag = qName;
    }

    /**
     * Trigger when element starts
     * @see DefaultHandler
     */
    public void endElement(String namespaceURI, String sName, String qName ) throws SAXException {
        priviousTag = "";
    }

    /**
     * Trigger when data starts
     * @see DefaultHandler
     */
    public void characters(char buf[], int offset, int len) throws SAXException {
        if( len != 0 && offset != 0 && priviousTag.equals("BODY"))
        {
            int i = 0;
            String temp = "";

            for(; i < len && (buf[offset + i] == ' ' || buf[offset + i] == '\t'); i++);

            for(; i < len; i++)
                temp += buf[offset + i];

            if(temp.length() != 0)
            {
                news.add(temp);
                priviousTag = "";
            }
        }
    }
}
